//+------------------------------------------------------------------+
//|                                                    SL_to_Bar.mq4 |
//|                               Copyright  2009,   |
//|                                                                  |
//+------------------------------------------------------------------+
/*:
 
:

    " "  SL:
          , /,  - /      ,        (    ,       -       ,     )
   .


//+------------------------------------------------------------------+
_BAR         -      SL
__BAR  - Purple;//  
BAR                  -    BAR  (  200)
show_bar          -      SL
//+------------------------------------------------------------------+

:
sl_to_bar.gif -   
sl_to_bar1.gif" -    

:
  SL    ,     
    show_bar = true*/
 
#property copyright "Copyright  2009,  "
#property link      "cmillion@narod.ru"

#property indicator_chart_window
//+------------------------------------------------------------------+
extern color _BAR      = DarkSlateGray;//     SL
extern color __BAR  = Purple;//  
extern int   BAR           = 200;//   BAR 
extern bool  show_bar      = true;//     SL
//+------------------------------------------------------------------+
int ,Ask_Bid;
color ;
//+------------------------------------------------------------------+
int init()
  {
      =Period();
      Ask_Bid = MarketInfo(Symbol(),MODE_STOPLEVEL);
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("SL-UP-bar ");
   ObjectDelete("SL-LO-bar ");
   ObjectDelete("SL-0-bar");
   ObjectDelete("SL  Sell ");
   ObjectDelete("SL  Bay ");
   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {
   double SL_Bay =Stop_Loss( 1);
   double SL_Sell=Stop_Loss(-1);
   string ;
   _(SL_Sell,SL_Bay);// Bay  Sell 
   for (int i=0; i<OrdersTotal(); i++)//    
   {
      if((OrderSelect(i, SELECT_BY_POS)==true) && (OrderSymbol()==Symbol())) //     .
      { 
         if (OrderType()<2)  //Bay  Sell
         {
            if (OrderStopLoss()==0)
            {
               =+" "+OrderTicket()+"  SL\n";
//               if (OrderType()==0) OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL_Bay ,Digits),OrderTakeProfit(),0,0);
//               if (OrderType()==1) OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL_Sell,Digits),OrderTakeProfit(),0,0);
            }
         }
      }
   }
   Comment();
   return(0);
  }
//
//////////////////////////////////////////////////////////////////////
//    Stop_Loss                                                     // 
//                                                                  //
//      SL            //
//                                                                  //
//     = 1 Bay           -1 Sell                         //
//                                                                  //
//////////////////////////////////////////////////////////////////////
double Stop_Loss(int ) 
{  
   int i;
   int timeframe,toBar,tf; 
   double SL_toBar,
          max_toBar,
          min_toBar;
   timeframe=_(+1);
   double max_ = iHigh( NULL, timeframe, 0);
   double min_ = iLow ( NULL, timeframe, 0);
   if (  ==1 ) //Bay
   {
      SL_toBar=0;
      for (toBar=1; toBar<BAR; toBar++)
      {
         max_toBar = iHigh( NULL, timeframe, toBar);
         min_toBar = iLow ( NULL, timeframe, toBar);
         if ( max_ > max_toBar && min_ > min_toBar) // 2 
         {
            SL_toBar = min_toBar-Point*Ask_Bid;
            if (show_bar==true){
               ObjectDelete("SL-UP-bar ");
               ObjectCreate("SL-UP-bar ", OBJ_RECTANGLE, 0, 0,0, 0,0);
               ObjectSet   ("SL-UP-bar ", OBJPROP_STYLE, STYLE_SOLID);
               ObjectSet   ("SL-UP-bar ", OBJPROP_COLOR, _BAR);
               ObjectSet   ("SL-UP-bar ", OBJPROP_BACK, true);
               ObjectSet   ("SL-UP-bar ", OBJPROP_TIME1 , iTime( NULL, timeframe, toBar-1));
               ObjectSet   ("SL-UP-bar ", OBJPROP_PRICE1, SL_toBar);
               ObjectSet   ("SL-UP-bar ", OBJPROP_TIME2 , iTime( NULL, timeframe, toBar));
               ObjectSet   ("SL-UP-bar ", OBJPROP_PRICE2, max_toBar);}
            break;
         }
      }
      if (SL_toBar==0)//  SL
      {  tf=timeframe;
         for (i=1; i<5; i++)
         {
            tf=_(tf+1);
            if ((iLow(NULL,_(tf+1),0)-Point*Ask_Bid) < (Bid-Point*Ask_Bid*3))
            {
               SL_toBar=iLow(NULL,_(tf+1),0)-Point*Ask_Bid;
               if (show_bar==true)
               {
                  //Comment("SL   ",SL_toBar);
                  ObjectDelete("SL-UP-bar ");
                  ObjectCreate("SL-UP-bar ", OBJ_RECTANGLE, 0, 0,0, 0,0);
                  ObjectSet   ("SL-UP-bar ", OBJPROP_STYLE, STYLE_SOLID);
                  ObjectSet   ("SL-UP-bar ", OBJPROP_COLOR, Red);
                  ObjectSet   ("SL-UP-bar ", OBJPROP_BACK, true);
                  ObjectSet   ("SL-UP-bar ", OBJPROP_TIME1 , iTime( NULL, tf, 0));
                  ObjectSet   ("SL-UP-bar ", OBJPROP_PRICE1, SL_toBar);
                  ObjectSet   ("SL-UP-bar ", OBJPROP_TIME2 , Time[0]);
                  ObjectSet   ("SL-UP-bar ", OBJPROP_PRICE2, Bid);
               }
               break;
            }
         }
      }
   }
   if (  ==-1 ) //Sell
   {
      SL_toBar=0;
      for (toBar=1; toBar<BAR; toBar++) 
      {
         max_toBar = iHigh( NULL, timeframe, toBar);
         min_toBar = iLow ( NULL, timeframe, toBar);
         if ( max_ < max_toBar && min_ < min_toBar) // 2 
         {
            SL_toBar = max_toBar+Point*Ask_Bid;
            if (show_bar==true){
               ObjectDelete("SL-LO-bar ");
               ObjectCreate("SL-LO-bar ", OBJ_RECTANGLE, 0, 0,0, 0,0);
               ObjectSet   ("SL-LO-bar ", OBJPROP_STYLE, STYLE_SOLID);
               ObjectSet   ("SL-LO-bar ", OBJPROP_COLOR, _BAR);
               ObjectSet   ("SL-LO-bar ", OBJPROP_BACK, true);
               ObjectSet   ("SL-LO-bar ", OBJPROP_TIME1 , iTime( NULL, timeframe, toBar-1));
               ObjectSet   ("SL-LO-bar ", OBJPROP_PRICE1, min_toBar);
               ObjectSet   ("SL-LO-bar ", OBJPROP_TIME2 , iTime( NULL, timeframe, toBar));
               ObjectSet   ("SL-LO-bar ", OBJPROP_PRICE2, SL_toBar);}
            break;
         }
      }
      if (SL_toBar==0)//  SL
      {  tf=timeframe;
         for (i=1; i<5; i++)
         {
            tf=_(tf+1);
            if ((iHigh(NULL,_(tf+1),0)+Point*Ask_Bid) > (Ask+Point*Ask_Bid*3))
            {
               SL_toBar=iHigh(NULL,_(tf+1),0)+Point*Ask_Bid;
               if (show_bar==true){
                  //Comment("SL   ",SL_toBar);
                  ObjectDelete("SL-LO-bar ");
                  ObjectCreate("SL-LO-bar ", OBJ_RECTANGLE, 0, 0,0, 0,0);
                  ObjectSet   ("SL-LO-bar ", OBJPROP_STYLE, STYLE_SOLID);
                  ObjectSet   ("SL-LO-bar ", OBJPROP_COLOR, Red);
                  ObjectSet   ("SL-LO-bar ", OBJPROP_BACK, true);
                  ObjectSet   ("SL-LO-bar ", OBJPROP_TIME1 , iTime( NULL, tf, 0));
                  ObjectSet   ("SL-LO-bar ", OBJPROP_PRICE1, Ask);
                  ObjectSet   ("SL-LO-bar ", OBJPROP_TIME2 , Time[0]);
                  ObjectSet   ("SL-LO-bar ", OBJPROP_PRICE2, SL_toBar);}
               break;
            }
         }
      }
   }
   if (show_bar==true){
      ObjectDelete("SL-0-bar");
      ObjectCreate("SL-0-bar", OBJ_RECTANGLE, 0, 0,0, 0,0);
      ObjectSet   ("SL-0-bar", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet   ("SL-0-bar", OBJPROP_COLOR, __BAR);
      ObjectSet   ("SL-0-bar", OBJPROP_BACK, true);
      ObjectSet   ("SL-0-bar", OBJPROP_TIME1 , iTime( NULL, timeframe, 0));
      ObjectSet   ("SL-0-bar", OBJPROP_PRICE1, min_);
      ObjectSet   ("SL-0-bar", OBJPROP_TIME2 , iTime( NULL, timeframe, 0)+timeframe*60);
      ObjectSet   ("SL-0-bar", OBJPROP_PRICE2, max_);}
   if ( == 0) return (0); //    
   return (SL_toBar);   
}
//////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////
double _(double , double ) //  SL     
{  
   =White;
   if (==0) {=Ask;=Red;}
   if ( ==0) { =Bid;=Red;}
   int =*3*60;
   if (show_bar==true)
   {
      ObjectDelete("SL  Sell ");
      ObjectCreate("SL  Sell ", OBJ_ARROW,0,Time[0]+,,0,0,0,0);
      ObjectSet   ("SL  Sell ", OBJPROP_ARROWCODE,6);
      ObjectSet   ("SL  Sell ", OBJPROP_COLOR, );
      ObjectSet   ("SL  Sell ", OBJPROP_BACK, true);
      ObjectDelete("SL  Bay ");
      ObjectCreate("SL  Bay ", OBJ_ARROW,0,Time[0]+,,0,0,0,0);
      ObjectSet   ("SL  Bay ", OBJPROP_ARROWCODE,6);
      ObjectSet   ("SL  Bay ", OBJPROP_COLOR, );
      ObjectSet   ("SL  Bay ", OBJPROP_BACK, true);
   }
}
//////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////
//
//
//*////////////////////////////////////////////////////////////////*//
int _(int per)
{
   if (per > 10080)  return(43200); 
   if (per > 1440)   return(10080); 
   if (per > 240)    return(1440); 
   if (per > 60)     return(240); 
   if (per > 30)     return(240);
   if (per > 15)     return(60); 
   if (per > 5)      return(30); 
   if (per > 1)      return(5);   
}
//*////////////////////////////////////////////////////////////////*//
//

